/*
 File: o2_code_end.h
 Date and Time: Fri Jan 30 18:55:16 2015 
*/
#ifndef __o2_code_end_h__
#define __o2_code_end_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"
extern yacco2::Thread_entry ITH_o2_code_end;

extern yacco2::State S1_Co2_code_end;
namespace NS_o2_code_end {
yacco2::THR _YACCO2_CALL_TYPE
TH_o2_code_end(yacco2::Parser* Caller);// called thread
yacco2::THR_result _YACCO2_CALL_TYPE
PROC_TH_o2_code_end(yacco2::Parser* Caller);// called thread's twin the procedure
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[1];
};
class Co2_code_end: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Ro2_code_end_ = 569//start_of_rule_list + 0
    ,rhs1_Ro2_code_end_ = 1
  };
  //no of la sets = 1
  //no of states = 4
  Co2_code_end();
  ~Co2_code_end();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[2];
 };
struct Ro2_code_end;
struct Ro2_code_end:public yacco2::CAbs_lr1_sym {
  Ro2_code_end(yacco2::Parser* P);
  public:
  void sr1();
};

} // end of namespace

#endif
